# FIXME: Use udev sooner or later...

%define     nvidialibdir      %{_libdir}/nvidia
%define     nvidialibdir32bit %{_prefix}/lib/nvidia
%define     nvversion 190.18

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Nvidia Display Driver and OpenGL libraries
Name: 		xorg-x11-drv-nvidia
Version: 	1.0.%{nvversion}
Release: 	1
Group: 		System/Configuration/Hardware
License: 	Distributable
URL:        	http://www.nvidia.com/
Source0:    	NVIDIA-Linux-x86-%{nvversion}-pkg1.run
Source1:    	NVIDIA-Linux-x86_64-%{nvversion}-pkg2.run
Source202:    	nvidia-glx.sh
Source203:    	nvidia-glx.csh
Source204:    	nvidia-settings.desktop
#Source11:   	nvidia-README.Fedora
Source212:   	nvidia-glx.opts

Source220:	51-nvidia.nodes

Provides:   	nvidia-kmod-common = %{version}

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

Conflicts:  	nvidia-glx-legacy
Conflicts:  	xorg-x11-drv-nvidia-legacy
BuildConflicts:	xorg-x11-drv-fglrx

Obsoletes:  	nvidia-glx

#Requires:   	kmod-nvidia >= %{version}
#Requires(post):  kmod-nvidia >= %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686
#Automatically resolved build dependencies
BuildRequires: atk-devel
BuildRequires: bash
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: gtk2+-devel
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: mesa-libGL-devel
BuildRequires: pango-devel
BuildRequires: xorg-x11-server-Xorg
BuildRequires: zlib-devel


%description
This package provides Nvidia hardware accelerated OpenGL support
for Nvidia chipsets from Geforce2, Quadro4 or newer.

%package devel
Summary:    Nvidia OpenGL Headers
Group:      Development/Libraries
Requires:   %{name} = %{version}-%{release}

%description devel
This package provides the Nvidia OpenGL headers and libraries required
for development.

%postun -p /sbin/ldconfig

%post -p /sbin/ldconfig

%prep
%setup -q -c -T
sh %{SOURCE0} --extract-only --target nvidiapkg-x86
sh %{SOURCE1} --extract-only --target nvidiapkg-x64
#tar -cvjf nvidia-glx-kmod-data-1.0.8178.tar.bz2 nvidiapkg-*/LICENSE nvidiapkg-*/usr/src/
%ifarch %{ix86}
ln -s nvidiapkg-x86 nvidiapkg
%else
ln -s nvidiapkg-x64 nvidiapkg
%endif
mv nvidiapkg/LICENSE nvidiapkg/usr/share/doc/
# More docs
find nvidiapkg/usr/share/doc/ -type f | xargs chmod 0644


%install
rm -rf $RPM_BUILD_ROOT

set +x
for file in $(cd nvidiapkg &> /dev/null; find . -type f | grep -v -e 'makeself.sh$' -e 'mkprecompiled$' -e 'tls_test$' -e 'tls_test_dso.so$' -e 'nvidia-settings.desktop$' -e '^./Makefile'  -e '^./nvidia-installer' -e '^./pkg-history.txt' -e '^./.manifest' -e '/usr/share/doc/' -e 'libGL.la$' -e 'drivers/nvidia_drv.o$' -e 'nvidia-installer.1.gz$' -e '^./usr/src/')
do
  if [[ ! "/${file##./usr/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/lib/}
  elif [[ ! "/${file##./usr/X11R6/lib/modules/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/extensions/nvidia/${file##./usr/X11R6/lib/modules/extensions}
  elif [[ ! "/${file##./usr/X11R6/lib/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/${file##./usr/X11R6/lib/modules}
  elif [[ ! "/${file##./usr/X11R6/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/X11R6/lib/}
  elif [[ ! "/${file##./usr/include/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_includedir}/nvidia/${file##./usr/include/}
  elif [[ ! "/${file##./usr/bin/}" = "/${file}" ]]
  then
    if [[ ! "/${file##./usr/bin/nvidia-xconfig}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/sbin/${file##./usr/bin/}
    elif [[ ! "/${file##./usr/bin/nvidia-bug-report.sh}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/bin/${file##./usr/bin/}
    else
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/${file}
    fi
  elif [[ ! "/${file##./usr/lib32}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/${file##./usr/lib32/}
  elif [[ ! "/${file##./usr/share/man/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
    gunzip $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
  elif [[ ! "/${file##./usr/share/pixmaps/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_datadir}/pixmaps/${file##./usr/share/pixmaps/}
  else
    echo ${file} found -- don\'t know how to handle
    exit 1
  fi
done
set -x

# Change perms on static libs. Can't fathom how to do it nicely above.
find $RPM_BUILD_ROOT/%{nvidialibdir} -type f -name "*.a" -exec chmod 0644 '{}' \;

# Fixme: should we do this directly in above for-loop? Yes, we should! No, please don't!
ln -s libGLcore.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGLcore.so
ln -s libGLcore.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGLcore.so.1
ln -s libGL.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGL.so
ln -s libGL.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGL.so.1
ln -s libnvidia-tls.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libnvidia-cfg.so.1
ln -s libXvMCNVIDIA.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA.so
ln -s libXvMCNVIDIA.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA_dynamic.so.1
ln -s libvdpau.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libvdpau.so.1
ln -s libvdpau.so.1 $RPM_BUILD_ROOT%{nvidialibdir}/libvdpau.so
ln -s libvdpau_trace.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libvdpau_trace.so
ln -s libvdpau_nvidia.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libvdpau_nvidia.so

ln -s libglx.so.%{nvversion} $RPM_BUILD_ROOT%{_libdir}/xorg/modules/extensions/nvidia/libglx.so

#ln -s libnvidia-wfb.so.%{nvversion} $RPM_BUILD_ROOT%{_libdir}/xorg/modules/libwfb.so


# 32-bit libs on x86_64
%ifarch x86_64
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so.1
ln -s libGL.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGL.so.1 
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-cfg.so.1
%endif # x86_64

# profile.d files
install -D -p -m 0755 %{SOURCE202} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.sh
install -D -p -m 0755 %{SOURCE203} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.csh

# modprobe.d file
install -D -p -m 0644 %{SOURCE212} $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/nvidia-glx.conf

# ld.so.conf.d file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/
echo "%{nvidialibdir}" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%ifarch x86_64
echo "%{nvidialibdir32bit}" >> $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%endif

# DRI device nodes
install -D -p -m 0644 %{SOURCE220} $RPM_BUILD_ROOT%{_sysconfdir}/udev/makedev.d/51-nvidia.nodes

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc nvidiapkg/usr/share/doc/*
%dir %{nvidialibdir}
%dir %{nvidialibdir}/tls
%dir %{_libdir}/xorg/modules/extensions/nvidia
#%{_initrddir}/nvidia-glx
%{nvidialibdir}/*.so.*
%{nvidialibdir}/tls/*.so.*
%{_sysconfdir}/profile.d/nvidia*
%{_libdir}/xorg/modules/drivers/nvidia_drv.so
%{_libdir}/xorg/modules/extensions/nvidia/*
%{_libdir}/xorg/modules/libnvidia-wfb.so*
#%{_libdir}/xorg/modules/libwfb.so
%{_bindir}/*
%{_sbindir}/*
#%{_datadir}/applications/*nvidia-settings.desktop
%{_datadir}/pixmaps/*.png
%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%{_sysconfdir}/modprobe.d/nvidia-glx.conf
%{_mandir}/man[1-9]/nvidia*.*
%{_sysconfdir}/udev/makedev.d/51-nvidia.nodes

%ifarch x86_64
%files libs-32bit
%dir %{nvidialibdir32bit}
%dir %{nvidialibdir32bit}/tls
%{nvidialibdir32bit}/*.so.*
%{nvidialibdir32bit}/tls/*.so.*
%endif  #x86_64


%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/nvidia
%dir %{_includedir}/nvidia/GL
%{_includedir}/nvidia/GL/*.h
%{_includedir}/nvidia/cuda/cuda.h
%{_includedir}/nvidia/cuda/cudaGL.h
%{_includedir}/nvidia/vdpau/vdpau.h
%{_includedir}/nvidia/vdpau/vdpau_x11.h
%{nvidialibdir}/libXvMCNVIDIA.a
%{nvidialibdir}/*.so
%ifarch x86_64
%{nvidialibdir32bit}/*.so
%endif #x86_64


%changelog
* Mon Jul 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.190.18-1
- Version update
* Wed Jun 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.19-2
- added .conf extension to modprobe config file
* Tue Apr 07 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.19-1
- Version update
* Fri Mar 20 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.13-1
- Version update
* Fri Jan 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.27-1
- Version update
* Sat Jan 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.22-1
- Version update
* Tue Dec 23 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.18-1
- Version update
* Sun Dec 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.16-1
- Version update
* Thu Dec 11 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.11-2
- added missing symlinks (vdpau*)
* Wed Dec 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.11-1
- Version update
* Thu Nov 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.08-1
- Version update
* Sat Nov 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.06-1
- Version update
* Thu Nov 13 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.82-1
- Version update
* Tue Oct 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-1
- Version update
* Sat Sep 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.78-1
- Version update
* Sat Sep 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.76-1
- Version update
* Thu Aug 28 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.70-1
- Version update
* Fri Aug 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.68-1
- Version update
* Thu Aug 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.67-1
- Version update
* Fri Aug 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-4
- collated device nodes creation in 51-nvidia.nodes file
* Wed Aug 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-3
- moved device files from /etc/udev/devices/ to /etc/udev/makedev.d/
* Mon Jul 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-2
- resolved circular dependency towards kmod package
* Sat Jun 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-1
- Version update
* Fri May 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.05-1
- Version update
* Tue May 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.08-1
- Version update
* Sat Mar 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-1
- Version update
* Tue Jan 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.09-1
- Version update
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.07-1
- Version update
* Sat Nov 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.04-1
- Version update
- readded 64bit version
* Mon Oct 22 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.23-1
- Version update, temp removed 64bit version, unneccessary for now.
* Wed Sep 19 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-1
- Version update, should work wirth newest Xorg now
* Fri Sep 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.11-4
- removed conflicting symlink
* Sat Sep 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.11-3
- rebuilt against X.org 7.3
* Mon Jun 25 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.11-2
- rebuilt with actual 100.14.11 sources
* Mon Jun 25 2007 Stefan Gottwald <gotti@ccux-linux.de> 1.0.100.14.11-1
- Version Update
* Fri Jun 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.09-3
- fixed other stray symlinks 
* Fri Jun 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.09-2
- fixed stray symlink
* Thu Jun 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.09-1
- Version update
* Mon Jun 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.06-1
- Version update
* Thu May 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.03-1
- Version update
* Fri Mar 16 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9755-2
- added missing symlink
* Thu Mar 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9755-1
- Version update
* Thu Jan 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9746-1
- Version update
* Sun Dec 10 2006 Stefan Gottwald <gotti@ccux-linux.de> 1.0.9631-1
- Version update
* Mon Sep 25 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9625-1
- Version update
* Thu Sep 14 2006 Christian Metzen <metzench@ccux-linux.de> 1.0.8774-1
- Version update, xorg 7.1
* Mon Jul 10 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.8762-1
- Version update
* Tue Apr 18 2006 Christian Metzen <metzench@ccux-linux.de> 1.0.8756-1
- Initial Release with new kmod helper
